import re
from headers import useragent

def is_valid_user_agent(user_agent):
    # Simple regex pattern to check if the user agent is non-empty and contains at least one alphanumeric character
    pattern = re.compile(r'[a-zA-Z0-9]')
    
    # Check if the user agent matches the pattern
    if pattern.search(user_agent):
        return True
    else:
        return False

# Example usage

for ua in useragent:
    print(f"Valid: {is_valid_user_agent(ua)}")
